diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/traps.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/traps.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/traps.c	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/traps.c	2005-08-12 15:41:58.000000000 -0600
@@ -44,6 +44,7 @@ const char *processor_modes[]=
 
 static const char *handler[]= { "prefetch abort", "data abort", "address exception", "interrupt" };
 
+#ifdef CONFIG_FRAME_POINTER
 /*
  * Stack pointers should always be within the kernels view of
  * physical memory.  If it is not there, then we can't dump
@@ -56,6 +57,7 @@ static int verify_stack(unsigned long sp
 
 	return 0;
 }
+#endif
 
 /*
  * Dump out the contents of some memory nicely...
@@ -184,12 +186,21 @@ NORET_TYPE void die(const char *str, str
 {
 	struct task_struct *tsk = current;
 
+#ifdef CONFIG_ADEOS_CORE
+       if (adp_current != adp_root)
+           adeos_set_printk_sync(adp_current);
+#endif /* CONFIG_ADEOS_CORE */
 	console_verbose();
 	spin_lock_irq(&die_lock);
 
 	printk("Internal error: %s: %x\n", str, err);
 	printk("CPU: %d\n", smp_processor_id());
 	show_regs(regs);
+#ifdef CONFIG_ADEOS_CORE
+       if (adp_current != adp_root)
+           printk("Adeos domain %s", adp_current->name);
+       else
+#endif /* CONFIG_ADEOS_CORE */
 	printk("Process %s (pid: %d, stack limit = 0x%p)\n",
 		current->comm, current->pid, tsk + 1);
 
@@ -285,6 +296,10 @@ asmlinkage void bad_mode(struct pt_regs 
 {
 	unsigned int vectors = vectors_base();
 
+#ifdef CONFIG_ADEOS_CORE
+       if (adp_current != adp_root)
+           adeos_set_printk_sync(adp_current);
+#endif /* CONFIG_ADEOS_CORE */
 	console_verbose();
 
 	printk(KERN_CRIT "Bad mode in %s handler detected: mode %s\n",
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/lib/udivdi3.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/lib/udivdi3.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/lib/udivdi3.c	2004-07-22 13:48:57.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/lib/udivdi3.c	2005-08-12 15:41:58.000000000 -0600
@@ -240,3 +240,42 @@ __umoddi3 (UDItype u, UDItype v)
   return w;
 }
 
+/* added signed variant for RTAI */
+
+static inline DItype
+__negdi2 (DItype u)
+{
+  DIunion w;
+  DIunion uu;
+
+  uu.ll = u;
+
+  w.s.low = -uu.s.low;
+  w.s.high = -uu.s.high - ((USItype) w.s.low > 0);
+
+  return w.ll;
+}
+
+DItype
+__divdi3 (DItype u, DItype v)
+{
+  word_type c = 0;
+  DIunion uu, vv;
+  DItype w;
+
+  uu.ll = u;
+  vv.ll = v;
+
+  if (uu.s.high < 0)
+    c = ~c,
+    uu.ll = __negdi2 (uu.ll);
+  if (vv.s.high < 0)
+    c = ~c,
+    vv.ll = __negdi2 (vv.ll);
+
+  w = __udivmoddi4 (uu.ll, vv.ll, (UDItype *) 0);
+  if (c)
+    w = __negdi2 (w);
+
+  return w;
+}
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/irq.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/irq.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/irq.c	2004-07-22 13:48:59.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/irq.c	2005-08-12 15:41:58.000000000 -0600
@@ -50,6 +50,24 @@
  *
  ************************************************************************/
 
+static void ep93xx_mask_ack_irq_timer1(unsigned int irq)
+{
+	outl((1 << IRQ_TIMER1), VIC0INTENCLEAR);
+	outl(1, TIMER1CLEAR);
+}
+ 
+static void ep93xx_mask_ack_irq_timer2(unsigned int irq)
+{
+	outl((1 << IRQ_TIMER2), VIC0INTENCLEAR);
+	outl(1, TIMER2CLEAR);
+}
+ 
+static void ep93xx_mask_ack_irq_timer3(unsigned int irq)
+{
+	outl((1 << (IRQ_TIMER3 - 32)), VIC1INTENCLEAR );
+	outl(1, TIMER3CLEAR);
+}
+ 
 static void ep93xx_mask_irq(unsigned int irq)
 {
 	if (irq < 32)
@@ -89,5 +107,10 @@ void __init ep93xx_init_irq(void)
 		irq_desc[i].mask	= ep93xx_mask_irq;
 		irq_desc[i].unmask	= ep93xx_unmask_irq;
 	}
+	/* let mask_ack of selected irqs really ack on hardware level 
+	 * (makes live a lot easier with Adeos) */
+	irq_desc[IRQ_TIMER1].mask_ack = ep93xx_mask_ack_irq_timer1;
+	irq_desc[IRQ_TIMER2].mask_ack = ep93xx_mask_ack_irq_timer2;
+	irq_desc[IRQ_TIMER3].mask_ack = ep93xx_mask_ack_irq_timer3;
+	/* TODO: add ack functions for other interrupts? */
 }
-
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/Makefile linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/Makefile
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/Makefile	2004-07-22 13:48:59.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/Makefile	2005-08-12 15:41:58.000000000 -0600
@@ -16,7 +16,7 @@ obj-m			:=
 obj-n			:=
 obj-			:=
 
-export-objs		:= pcipool.o
+export-objs		:= time.o ssp.o
 
 obj-$(CONFIG_EP93XX_DMA)+= dma_ep93xx.o
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/ssp.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/ssp.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/ssp.c	2004-07-22 13:48:59.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/ssp.c	2005-08-12 15:41:58.000000000 -0600
@@ -28,6 +28,7 @@
  *  I2S Codec CS4228        = EGPIO7 == 1
  *  Serial Flash AT25F1024  = EGPIO7 == 0
  */
+#include <linux/module.h>
 #include <linux/delay.h>
 #include <asm/irq.h>
 
@@ -692,3 +693,5 @@ static int SSP_Write_I2SCodec
 	 */
 	return 0;
 }
+
+EXPORT_SYMBOL(SSPDriver);
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/time.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/time.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mach-ep93xx/time.c	2004-07-22 13:48:59.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mach-ep93xx/time.c	2005-08-12 15:41:58.000000000 -0600
@@ -6,19 +6,33 @@
  * (c) Copyright 2001 LynuxWorks, Inc., San Jose, CA.  All rights reserved.
  *  Copyright (C) 2002-2003 Cirrus Logic, Inc.
  *
+ * Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ * 	tie wall-clock to TSC (i.e. timer4)
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  */
+#include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/sched.h>
 #include <linux/init.h>
+#include <linux/module.h>
 
 #include <asm/hardware.h>
 #include <asm/io.h>
+#include <asm/arch-ep93xx/ep93xx_tsc.h>
 
 extern int (*set_rtc)(void);
 
+/* EP93XX-based 64 bit TSC (overflow time: ~600000 years) */
+volatile ep93xx_tsc_t ep93xx_tsc;
+
+/* jiffies counter without overflow problems (overflow time: ~6 billion years
+ * @ HZ=100) to keep jiffies in sync with TSC) */
+volatile unsigned long long ep93xx_jiffies_done;
+
+
 static int ep93xx_set_rtc(void)
 {
 	outl( xtime.tv_sec, RTCLR );
@@ -37,7 +51,58 @@ static int ep93xx_rtc_init(void)
 	return 0;
 }
 
-__initcall(ep93xx_rtc_init);
+//__initcall(ep93xx_rtc_init);
+
+
+/* return time since last jiffy tick, in usecs */
+static unsigned long
+ep93xx_gettimeoffset(void)
+{
+    /* Reading 64-bit value ep93xx_jiffies_done is safe although it is modified
+     * in timer interrupt handler (because this function is called with irqs disabled).
+     * This is even true for RTAI (value is only modified in Linux context). */
+    unsigned long long tsc_offset = ep93xx_rdtsc() - (ep93xx_jiffies_done * FREQ_EP93XX_TSC) / HZ;
+    return (tsc_offset * 1000000LLU) / (unsigned long long)FREQ_EP93XX_TSC;
+}
+
+/* set up EP93xx timers */
+void __init
+ep93xx_setup_timer(void)
+{
+    extern unsigned long (*gettimeoffset)(void);
+    gettimeoffset = ep93xx_gettimeoffset;
 
+    /*
+     * Timer 1 is used to generate the periodic jiffies timer interrupt.
+     * It has a clock frequency of ca. 508.47 kHz.
+     *
+     * Timer 4 is the upwards counting time-stamp counter (TSC). It has a exact
+     * clock frequency of 983.04 kHz and is used as an absolute reference
+     * clock, i.e. jiffies are synced to it (makes life a lot easier with
+     * RTAI) and the wall-clock time-offset is also calculated from it (so RTAI
+     * can change timer 1's load-value without effecting the wall-clock).
+     */
+
+    /* set up 64 bit tsc and jiffies handling */
+    ep93xx_tsc.ll = 0;
+    ep93xx_jiffies_done = 0;
+
+    /* disable timers */
+    outl(0, TIMER1CONTROL);
+    outl(0, TIMER4VALUEHIGH);
+
+    /* set timer 1 reload value for periodic mode (defined by value of
+     * include/asm-arm/arch-ep93xx/timex.h:CLOCK_TICK_RATE) */
+    outl(LATCH - 1, TIMER1LOAD);
+
+    /* start timers */
+    outl(0x100, TIMER4VALUEHIGH);	/* 983.04 kHz clock */
+    outl(0xc8, TIMER1CONTROL);		/* periodic mode, 508 kHz clock */
 
+    xtime.tv_sec = inl(RTCDR);
+}
 
+#ifdef CONFIG_ADEOS_CORE
+EXPORT_SYMBOL(ep93xx_tsc);
+EXPORT_SYMBOL(ep93xx_jiffies_done);
+#endif /* CONFIG_ADEOS_CORE */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/Makefile linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/Makefile
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/Makefile	2004-08-23 09:50:06.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/Makefile	2005-08-12 15:41:58.000000000 -0600
@@ -13,7 +13,7 @@ GZFLAGS		:=-9
 CFLAGS		+=-Uarm -fno-common -pipe
 
 ifeq ($(CONFIG_FRAME_POINTER),y)
-CFLAGS		:=$(CFLAGS:-fomit-frame-pointer=-mapcs -mno-sched-prolog)
+CFLAGS		+=-fno-omit-frame-pointer -mapcs -mno-sched-prolog
 endif
 
 CFLAGS		:=$(CFLAGS:-O2=-Os)
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mm/ioremap.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mm/ioremap.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mm/ioremap.c	2004-08-03 19:25:39.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mm/ioremap.c	2005-08-12 15:41:58.000000000 -0600
@@ -107,6 +107,9 @@ remap_area_pages(unsigned long address, 
 		if (remap_area_pmd(pmd, address, end - address,
 					 pfn + (address >> PAGE_SHIFT), flags))
 			break;
+#ifdef CONFIG_ADEOS_CORE
+		set_pgdir(address, *dir);
+#endif
 		error = 0;
 		address = (address + PGDIR_SIZE) & PGDIR_MASK;
 		dir++;
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mm/proc-arm920.S linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mm/proc-arm920.S
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/mm/proc-arm920.S	2004-08-03 19:25:39.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/mm/proc-arm920.S	2005-08-12 15:41:58.000000000 -0600
@@ -465,8 +465,8 @@ ENTRY(cpu_arm920_set_pgd)
 	bcs	2b				@ entries 63 to 0
 	subs	r1, r1, #1 << 5
 	bcs	1b				@ segments 7 to 0
-#endif
 	mcr	p15, 0, ip, c7, c5, 0		@ invalidate I cache
+#endif
 	mcr	p15, 0, ip, c7, c10, 4		@ drain WB
 	mcr	p15, 0, r0, c2, c0, 0		@ load page table pointer
 	mcr	p15, 0, ip, c8, c7, 0		@ invalidate I & D TLBs
@@ -576,6 +576,13 @@ __arm920_setup:
 #ifndef CONFIG_CPU_ICACHE_DISABLE
 	orr	r0, r0, #0x1000			@ ...1 .... .... ....
 #endif
+#if 0 /* don't use it, no improvment in avg/worst case latency */
+#ifdef CONFIG_ADEOS_CORE
+	@ enable round-robin cache replacement
+	@ (because worst case it is more predictable)
+	orr	r0, r0, #0x4000			@ .1.. .... .... ....
+#endif /* CONFIG_ADEOS_CORE */
+#endif
 	mov	pc, lr
 
 	.text
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/drivers/char/tty_io.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/drivers/char/tty_io.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/drivers/char/tty_io.c	2004-08-03 19:28:46.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/drivers/char/tty_io.c	2005-08-12 15:41:58.000000000 -0600
@@ -1948,12 +1948,12 @@ static void flush_to_ldisc(void *private
 		queue_task(&tty->flip.tqueue, &tq_timer);
 		return;
 	}
+	save_flags(flags); cli();
 	if (tty->flip.buf_num) {
 		cp = tty->flip.char_buf + TTY_FLIPBUF_SIZE;
 		fp = tty->flip.flag_buf + TTY_FLIPBUF_SIZE;
 		tty->flip.buf_num = 0;
 
-		save_flags(flags); cli();
 		tty->flip.char_buf_ptr = tty->flip.char_buf;
 		tty->flip.flag_buf_ptr = tty->flip.flag_buf;
 	} else {
@@ -1961,7 +1961,6 @@ static void flush_to_ldisc(void *private
 		fp = tty->flip.flag_buf;
 		tty->flip.buf_num = 1;
 
-		save_flags(flags); cli();
 		tty->flip.char_buf_ptr = tty->flip.char_buf + TTY_FLIPBUF_SIZE;
 		tty->flip.flag_buf_ptr = tty->flip.flag_buf + TTY_FLIPBUF_SIZE;
 	}
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/drivers/serial/ep93xx_amba.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/drivers/serial/ep93xx_amba.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/drivers/serial/ep93xx_amba.c	2004-08-24 13:26:50.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/drivers/serial/ep93xx_amba.c	2005-08-12 15:41:58.000000000 -0600
@@ -348,11 +348,30 @@ csambauart_rx_chars(struct uart_port *po
 	status = UART_GET_FR(port);
 	while (UART_RX_DATA(status) && max_count--) {
 		if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
+#if 1
+			/* no room in flip buffer (TTY_DONT_FLIP is set),
+			 * discard rx FIFO contents to clear IRQ *FIXME*
+			 * Hardware with auto flow control would benefit from
+			 * leaving the data in the FIFO and disabling the rx IRQ
+			 * until space becomes available. */
+			do {
+				UART_GET_CHAR(port);
+				port->icount.overrun++;
+				status = UART_GET_FR(port);
+			} while (UART_RX_DATA(status) && (max_count-- > 0));
+			return;
+#else
+			/* calling this from irq is not allowed (although a lot
+			 * of drivers do it, but with Adeos it really shows!)
+			 * -<mike@firmix.at> */
 			tty->flip.tqueue.routine((void *)tty);
 			if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
-				printk(KERN_WARNING "TTY_DONT_FLIP set\n");
+				/* having this here is dangerous (system-lock up
+				 * due to message flood) -<mike@firmix.at> */
+				/* printk(KERN_WARNING "TTY_DONT_FLIP set\n"); */
 				return;
 			}
+#endif
 		}
 
 		ch = UART_GET_CHAR(port);
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/adeos.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/adeos.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/adeos.h	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/adeos.h	2005-08-12 15:41:58.000000000 -0600
@@ -0,0 +1,321 @@
+/*
+ *   include/asm-arm/adeos.h
+ *
+ *   Copyright (C) 2002,2003,2004 Philippe Gerum.
+ *
+ *   Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ *	support for EP9301, backport of unthreaded support from Adeos/x86 for 2.6
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __ARM_ADEOS_H
+#define __ARM_ADEOS_H
+
+struct task_struct;
+
+#include <asm/irq.h>
+#include <asm/siginfo.h>
+#include <asm/ptrace.h>
+#include <asm/bitops.h>
+#include <linux/list.h>
+#include <linux/threads.h>
+#include <asm/arch/hardware.h>
+#include <asm/arch/irqs.h>
+
+#ifdef CONFIG_ARCH_EP9301
+#define ADEOS_ARCH_STRING	"r17c3/arm-ep9301"
+#define ADEOS_MAJOR_NUMBER	17
+#define ADEOS_MINOR_NUMBER	3
+#define ADEOS_TIMER_IRQ		IRQ_TIMER1
+#else
+#error "Adeos: unsupported ARM architecture, sorry..."
+#endif /* CONFIG_ARCH_EP9301 */
+
+typedef unsigned long cpumask_t;
+#define CPU_MASK_NONE		((cpumask_t)0)
+
+#define ADEOS_NR_CPUS          1
+#define adeos_processor_id()   0
+/* Array references using this index should be optimized out. */
+#define adeos_declare_cpuid    const int cpuid = 0
+#define adeos_load_cpuid()      do { /* nop */ } while(0)
+#define adeos_lock_cpu(flags)   adeos_hw_local_irq_save(flags)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    do { flags = flags; } while(0)
+#define adeos_put_cpu(flags)    do { /* nop */ } while(0)
+#define adp_current             (adp_cpu_current[0])
+
+/* ARM fault traps */
+#define ADEOS_NR_FAULTS         32
+/* Pseudo-vectors used for kernel events */
+#define ADEOS_FIRST_KEVENT      ADEOS_NR_FAULTS
+#define ADEOS_SYSCALL_PROLOGUE  (ADEOS_FIRST_KEVENT)
+#define ADEOS_SYSCALL_EPILOGUE  (ADEOS_FIRST_KEVENT + 1)
+#define ADEOS_SCHEDULE_HEAD     (ADEOS_FIRST_KEVENT + 2)
+#define ADEOS_SCHEDULE_TAIL     (ADEOS_FIRST_KEVENT + 3)
+#ifdef CONFIG_ADEOS_EVENT_ENTER_PROCESS
+#define ADEOS_ENTER_PROCESS     (ADEOS_FIRST_KEVENT + 4)
+#endif /* CONFIG_ADEOS_EVENT_ENTER_PROCESS */
+#define ADEOS_EXIT_PROCESS      (ADEOS_FIRST_KEVENT + 5)
+#define ADEOS_SIGNAL_PROCESS    (ADEOS_FIRST_KEVENT + 6)
+#define ADEOS_KICK_PROCESS      (ADEOS_FIRST_KEVENT + 7)
+#define ADEOS_LAST_KEVENT       (ADEOS_KICK_PROCESS)
+#ifdef CONFIG_ADEOS_EVENT_RENICE_PROCESS
+#define ADEOS_RENICE_PROCESS    (ADEOS_FIRST_KEVENT + 8)
+#undef ADEOS_LAST_KEVENT
+#define ADEOS_LAST_KEVENT       (ADEOS_RENICE_PROCESS)
+#endif /* CONFIG_ADEOS_EVENT_RENICE_PROCESS */
+#ifdef CONFIG_ADEOS_EVENT_USER_PROCESS
+#define ADEOS_USER_EVENT        (ADEOS_FIRST_KEVENT + 9)
+#undef ADEOS_LAST_KEVENT
+#define ADEOS_LAST_KEVENT       (ADEOS_USER_EVENT)
+#endif /* !CONFIG_ADEOS_EVENT_USER_PROCESS */
+
+#define ADEOS_NR_EVENTS         (ADEOS_LAST_KEVENT + 1)
+
+typedef struct adevinfo {
+
+    unsigned domid;
+    unsigned event;
+    void *evdata;
+
+    volatile int propagate;	/* Private */
+
+} adevinfo_t;
+
+typedef struct adsysinfo {
+
+    int ncpus;			/* Number of CPUs on board */
+
+    unsigned long long cpufreq;	/* CPU frequency (in Hz) */
+
+    /* Arch-dependent block */
+
+    struct {
+	unsigned tmirq;		/* Timer tick IRQ */
+    } archdep;
+
+} adsysinfo_t;
+
+#define IPIPE_NR_XIRQS   NR_IRQS
+/* Number of virtual IRQs */
+#define IPIPE_NR_VIRQS   BITS_PER_LONG
+/* First virtual IRQ # */
+#define IPIPE_VIRQ_BASE  (((IPIPE_NR_XIRQS + BITS_PER_LONG - 1) / BITS_PER_LONG) * BITS_PER_LONG)
+/* Total number of IRQ slots */
+#define IPIPE_NR_IRQS     (IPIPE_VIRQ_BASE + IPIPE_NR_VIRQS)
+/* Number of indirect words needed to map the whole IRQ space. */
+#define IPIPE_IRQ_IWORDS  ((IPIPE_NR_IRQS + BITS_PER_LONG - 1) / BITS_PER_LONG)
+#define IPIPE_IRQ_IMASK   (BITS_PER_LONG - 1)
+#define IPIPE_IRQ_ISHIFT  5	/* 2^5 for 32bits arch. */
+
+#define IPIPE_IRQMASK_ANY   (~0UL)
+#define IPIPE_IRQMASK_VIRT  (IPIPE_IRQMASK_ANY << (IPIPE_VIRQ_BASE / BITS_PER_LONG))
+
+typedef struct adomain {
+
+    /* -- Section: offset-based references may be made on these fields
+       from inline assembly code. Please don't move or reorder. */
+    void (*dswitch)(void)	/* Domain switch hook */
+	__attribute__ ((__aligned__ (32))); /* align every element of array (gcc bug workaround) */
+#ifdef CONFIG_ADEOS_THREADS
+    int *esp[ADEOS_NR_CPUS];	/* Domain stack pointers */
+#endif /* CONFIG_ADEOS_THREADS */
+    /* -- End of section. */
+
+    struct list_head p_link;	/* Link in pipeline */
+
+    struct adcpudata {
+	volatile unsigned long status;
+	volatile unsigned long irq_pending_hi;
+	volatile unsigned long irq_pending_lo[IPIPE_IRQ_IWORDS];
+	volatile unsigned irq_hits[IPIPE_NR_IRQS];
+#ifdef CONFIG_ADEOS_THREADS
+	adevinfo_t event_info;
+#endif /* CONFIG_ADEOS_THREADS */
+    } cpudata[ADEOS_NR_CPUS];
+
+    struct {
+	int (*acknowledge)(unsigned irq);
+	void (*handler)(unsigned irq);
+	unsigned long control;
+    } irqs[IPIPE_NR_IRQS];
+
+    struct {
+	void (*handler)(adevinfo_t *evinfo);
+    } events[ADEOS_NR_EVENTS];
+
+    unsigned long flags;
+
+    struct adomain *m_link;	/* Link in mutex sleep queue */
+
+    unsigned domid;
+
+    const char *name;
+
+    int priority;
+
+    int ptd_keymax;
+    int ptd_keycount;
+    unsigned long ptd_keymap;
+    void (*ptd_setfun)(int, void *);
+    void *(*ptd_getfun)(int);
+
+#ifdef CONFIG_ADEOS_THREADS
+    int *estackbase[ADEOS_NR_CPUS];
+#endif /* CONFIG_ADEOS_THREADS */
+
+} adomain_t __attribute__ ((__aligned__ (32)));
+
+#define adeos_hw_test_iflag(x)        (!((x) & I_BIT)) /* We don't use the FIRQs */
+
+#define adeos_hw_irqs_disabled()	\
+({					\
+	unsigned long flags;		\
+	adeos_hw_local_irq_flags(flags);	\
+	!adeos_hw_test_iflag(flags);	\
+})
+
+/* The following macros must be used hw interrupts off. */
+
+#define __adeos_set_irq_bit(adp,cpuid,irq) \
+do { \
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled()); \
+    if (!test_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) { \
+        __set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+        __set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+       } \
+} while(0)
+
+#define __adeos_clear_pend(adp,cpuid,irq) \
+do { \
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled()); \
+    __clear_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+    if ((adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT] == 0) \
+        __clear_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+} while(0)
+
+#define __adeos_lock_irq(adp,cpuid,irq) \
+do { \
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled()); \
+    if (!__test_and_set_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	__adeos_clear_pend(adp,cpuid,irq); \
+} while(0)
+
+#define __adeos_unlock_irq(adp,irq) \
+do { \
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled()); \
+    int __cpuid, __nr_cpus = smp_num_cpus;			       \
+    if (__test_and_clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++)      \
+         if ((adp)->cpudata[__cpuid].irq_hits[irq] > 0) { \
+           __set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[__cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+           __set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[__cpuid].irq_pending_hi); \
+         } \
+} while(0)
+
+#define __adeos_clear_irq(adp,irq) \
+do { \
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled()); \
+    int __cpuid, __nr_cpus = smp_num_cpus; \
+    __clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control); \
+    for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++) {	\
+       (adp)->cpudata[__cpuid].irq_hits[irq] = 0; \
+       __adeos_clear_pend(adp,__cpuid,irq); \
+    } \
+} while(0)
+
+#define adeos_virtual_irq_p(irq)		((irq) >= IPIPE_VIRQ_BASE && (irq) < IPIPE_NR_IRQS)
+
+#define adeos_hw_save_flags_and_sti(x)		do { adeos_hw_local_irq_flags(x); adeos_hw_sti(); } while(0)
+
+#define adeos_hw_tsc(t)				0
+#define adeos_cpu_freq()			CLOCK_TICK_RATE
+
+#ifdef CONFIG_PREEMPT
+#define adeos_spin_lock(x)   			_raw_spin_lock(x)
+#define adeos_spin_unlock(x) 			_raw_spin_unlock(x)
+#define adeos_spin_trylock(x)			_raw_spin_trylock(x)
+#else /* !CONFIG_PREEMPT */
+#define adeos_spin_lock(x)   			spin_lock(x)
+#define adeos_spin_unlock(x) 			spin_unlock(x)
+#define adeos_spin_trylock(x)			spin_trylock(x)
+#endif /* CONFIG_PREEMPT */
+
+#define adeos_spin_lock_irqsave(x,flags)	do { adeos_hw_local_irq_save(flags); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_irqrestore(x,flags)	do { adeos_spin_unlock(x); adeos_hw_local_irq_restore(flags); } while (0)
+#define adeos_spin_lock_disable(x)		do { adeos_hw_cli(); adeos_spin_lock(x); } while (0)
+#define adeos_spin_unlock_enable(x)		do { adeos_spin_unlock(x); adeos_hw_sti(); } while (0)
+
+/* Private interface -- Internal use only */
+
+struct adattr;
+
+void __adeos_init(void);
+
+void __adeos_init_domain(adomain_t *adp,
+			 struct adattr *attr);
+
+void __adeos_cleanup_domain(adomain_t *adp);
+
+#define __adeos_check_machine() do { } while(0)
+
+void __adeos_enable_pipeline(void);
+
+void __adeos_disable_pipeline(void);
+
+void __adeos_init_stage(adomain_t *adp);
+
+void FASTCALL(__adeos_sync_stage(unsigned long syncmask));
+
+void __adeos_tune_timer(unsigned long hz);
+
+asmlinkage int __adeos_handle_irq(int irq,
+				   struct pt_regs *regs);
+
+#ifdef CONFIG_ADEOS_THREADS
+
+asmlinkage int __adeos_switch_domain(adomain_t *adp,
+				     adomain_t **currentp);
+
+/* Called with hw interrupts off. */
+extern inline void __adeos_switch_to(adomain_t *out,
+				     adomain_t *in,
+				     int cpuid)
+{
+    extern adomain_t *adp_cpu_current[];
+
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled());
+
+    __adeos_switch_domain(in,&adp_cpu_current[cpuid]);
+
+    if (out->dswitch != NULL)
+	out->dswitch();
+}
+
+#endif /* CONFIG_ADEOS_THREADS */
+
+extern struct pt_regs __adeos_irq_regs;
+
+/* hook for non-Linux syscalls (i.e. RTAI syscall) (see linux/arch/arm/kernel/entry-common.S) */
+extern int (*adeos_syscall_entry)(struct pt_regs *regs);
+
+/* hook for interrupt handling (default value: __adeos_handle_irq, see
+ * linux/arch/arm/kernel/entry-armv.S) */
+extern int (*adeos_irq_entry)(int irq, struct pt_regs *regs);
+
+#endif /* !__ARM_ADEOS_H */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/ep93xx_tsc.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/ep93xx_tsc.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/ep93xx_tsc.h	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/ep93xx_tsc.h	2005-08-12 15:41:58.000000000 -0600
@@ -0,0 +1,122 @@
+/*
+ * linux/include/asm-arm/arch-ep93xx/ep93xx_rdtsc.h
+ *
+ * 64 bit time-stamp counter (TSC) for absolute real-time clock without
+ * overflow-problems (>1/2 million years).
+ *
+ * Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH <mike@firmix.at>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#ifndef __ASM_ARM_ARCH_EP93XX_H_
+#define __ASM_ARM_ARCH_EP93XX_H_
+
+/* tsc's clock frequency (EP93XX's timer 4) */
+#define FREQ_EP93XX_TSC	(983040)
+
+#ifdef __KERNEL__
+
+#include <linux/config.h>
+#include <asm/system.h>
+#include <asm/io.h>
+#include <asm/arch/hardware.h>
+
+/* jiffies counter without overflow problems (overflow time: ~6 billion years
+ * @ HZ=100) to keep Linux-jiffies in sync with 64 bit TSC */
+extern volatile unsigned long long ep93xx_jiffies_done;
+
+/*
+ * 64 bit tsc from hardware's 32 bit tsc, hardware has actually 40 bits, but
+ * even this is not enough to avoid an overflow during a reboot-less time (for
+ * a TSC clock frequency of 983040 Hz):
+ *	bits	overflow
+ *	32	1.2 hours
+ *	40	13 days
+ *	64	595034 years
+ */
+typedef union _ep93xx_tsc_t {
+    unsigned long long	ll;
+    struct {
+	unsigned long	low;
+	unsigned long	high;
+    } u;
+} ep93xx_tsc_t;
+extern volatile ep93xx_tsc_t ep93xx_tsc;
+
+/* read EP93XX-based 64 bit TSC irq-safe (overflow time: ~600000 years) */
+extern inline unsigned long long
+ep93xx_rdtsc(void)
+{
+    register ep93xx_tsc_t tsc;
+    register unsigned long low_now;
+    
+    /* get snapshot of global tsc (ldm is irq-safe!) */
+    __asm__(
+	"ldmia %[glbl_tsc], %M[tsc]\n"
+	: /* output */	[tsc] "=r" (tsc.ll)
+	: /* input  */	[glbl_tsc] "r" (&ep93xx_tsc.ll),
+			"m" (ep93xx_tsc)
+    );
+    /* read current low tsc (i.e. low 32 bits of hardware timer) */
+    low_now = inl(TIMER4VALUELOW);
+    /* check for overflow in relation to global ep93xx_tsc and correct high 32
+     * bits if necessary */
+    if (low_now < tsc.u.low)
+	++tsc.u.high;
+    tsc.u.low = low_now;
+    return tsc.ll;
+}
+
+/* irq-safe read & update in-memory tsc (good place to call this is the 100 HZ
+ * interrupt) */
+extern inline unsigned long long
+ep93xx_read_and_update_tsc(void)
+{
+    register ep93xx_tsc_t tsc;
+    register unsigned long low_now;
+    int do_update;
+
+    /* get snapshot of global tsc (ldm is irq safe!) */
+    __asm__(
+	"ldmia %[glbl_tsc], %M[tsc]\n"
+	: /* output */	[tsc] "=r" (tsc.ll)
+	: /* input  */	[glbl_tsc] "r" (&ep93xx_tsc.ll),
+			"m" (ep93xx_tsc)
+    );
+    /* read current low tsc (i.e. low 32 bits of hardware timer) */
+    low_now = inl(TIMER4VALUELOW);
+    /* check for overflow in relation to global ep93xx_tsc and correct high 32
+     * bits if necessary */
+    if (low_now < tsc.u.low)
+	++tsc.u.high;
+    /* update at least 4 times per period (i.e. each 18 minutes) */
+    do_update = (low_now - tsc.u.low >= 0x40000000);
+    tsc.u.low = low_now;
+    if (do_update) {
+	/* update global tsc (stm is irq-safe!) */
+	__asm__(
+	    "stmia %[glbl_tsc], %M[tsc]\n"
+	    : /* output */	"=m" (ep93xx_tsc)
+	    : /* input  */	[tsc] "r" (tsc.ll),
+	    			[glbl_tsc] "r" (&ep93xx_tsc.ll)
+	);
+    }
+
+    return tsc.ll;
+}
+
+#endif /* __KERNEL */
+
+#endif /* __ASM_ARM_ARCH_EP93XX_H_ */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/irq.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/irq.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/irq.h	2004-07-22 13:50:54.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/irq.h	2005-08-12 15:41:58.000000000 -0600
@@ -17,4 +17,9 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
+#ifndef _ASM_ARCH_EP93XX_IRQ_H
+#define _ASM_ARCH_EP93XX_IRQ_H
+
 #define fixup_irq(i)	(i)
+
+#endif /* _ASM_ARCH_EP93XX_IRQ_H */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/system.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/system.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/system.h	2004-09-10 12:47:33.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/system.h	2005-08-12 15:41:58.000000000 -0600
@@ -21,16 +21,17 @@
 #ifndef __ASM_ARCH_SYSTEM_H
 #define __ASM_ARCH_SYSTEM_H
 
+#include <linux/config.h>
 #include <asm/arch/platform.h>
 #include <asm/hardware.h>
 #include <asm/io.h>
 
-static void arch_idle(void)
+static inline void arch_idle(void)
 {
 	cpu_do_idle();
 }
 
-extern __inline__ void arch_reset(char mode)
+extern inline void arch_reset(char mode)
 {
     //
     // Enable the watchdog timer so that it will reset the part.
